﻿Imports System.Windows.Forms
Imports m8 = Mates8
Imports System.Drawing
Imports System.IO

Public Class Graph
    Dim chart1 As DataVisualization.Charting.Chart
    Dim p As Polynomial
    Dim title As String
    Dim cfg As New Config
    Public lst As New List(Of KeyValuePair(Of String, String))
    Public Sub New(poly As m8.Polynomial)
        Try
            chart1 = New DataVisualization.Charting.Chart
            With chart1
                .Width = 300
                .Height = 300
            End With
            Dim fnt As New Font("Courier New", 12)
            p = poly
            title = p.toStringPoly(cfg)
            chart1.Titles.Add(title)
            chart1.Titles(0).Font = fnt
            chart1.ChartAreas.Clear()
            chart1.ChartAreas.Add("Default")

            With chart1.ChartAreas("Default")
                .AxisX.Title = p.var(0) ' x
                .AxisX.MajorGrid.LineColor = Color.SkyBlue
                .AxisY.MajorGrid.LineColor = Color.SkyBlue
                .AxisY.TitleFont = fnt
                .AxisY.LabelAutoFitMinFontSize = 12
                .AxisX.TitleFont = fnt
                '               f function = &H192
                .AxisY.Title = "ƒ(" + title + ")"
            End With
        Catch ex As Exception

        End Try
    End Sub
    Public Sub New()
        chart1 = New DataVisualization.Charting.Chart
    End Sub
    Function draw2(sFn As String, [from] As Double, [to] As Double, [step] As Double, decimals As Int32, bRnd As Boolean) As _
            matrixParser
        Static vX(-1) As Double
        Static vY(-1) As Double
        Dim mP As New matrixParser
        Try
            chart1 = New DataVisualization.Charting.Chart
            With chart1
                .Width = 300
                .Height = 300
            End With

            Dim cfg As New Config
            cfg.bRounding = bRnd
            cfg.bCaseSensitive = True
            If Not bRnd Then decimals = 15
            If decimals >= 0 Then cfg.nDecimals = decimals
            decimals = cfg.nDecimals
            mP.parse(sFn, cfg:=cfg)
            Dim vars As VarsAndFns = mP.getVars
            Dim sVar As String = vars.getNamesList(0)

            Dim fnt As New Font("Courier New", 12)
            title = "ƒ(" + sVar + ") = " + sFn
            chart1.Titles.Add(title)
            chart1.Titles(0).Font = fnt
            chart1.ChartAreas.Clear()
            chart1.ChartAreas.Add("Default")
            Dim AxisX As New DataVisualization.Charting.Axis
            'Dim AxisY As New DataVisualization.Charting.Axis
            With chart1.ChartAreas("Default")
                AxisX.Title = sVar
                AxisX.MajorGrid.LineColor = Color.SkyBlue
                .AxisY.MajorGrid.LineColor = Color.SkyBlue
                .AxisY.TitleFont = fnt
                .AxisY.LabelAutoFitMinFontSize = 12
                AxisX.TitleFont = fnt
                '               f function = &H192
                .AxisY.Title = "ƒ(" + sVar + ") "
            End With
            chart1.Series.Clear()
            Dim sX As String = sVar
            chart1.Series.Add(sX)
            'chart1.Series(sX).IsXValueIndexed = False
            chart1.Series(sX).Color = Color.Red
            chart1.Series(sX).ChartType = DataVisualization.Charting.SeriesChartType.Point
            Dim bReal As Boolean = True
            If mP.ret.exprMtx.Rows + mP.ret.exprMtx.Cols = 2 Then
                For x As Double = [from] To [to] Step [step]
                    'calculate the y value for each x value
                    'then add that point to the series line
                    Dim y As Complex = Nothing
                    Try
                        y = mP.ret.curExpr.eval_1var_DblToCjo(x)
                    Catch ex As Exception
                        y = New Complex(Int32.MaxValue)
                    End Try
                    Dim x1 As New Complex(x)
                    Dim y1 As New Complex(y)
                    lst.Add(New KeyValuePair(Of String, String)(x1.toString(cfg), y1.toString(cfg)))
                    chart1.Series(sX).Points.AddXY(x, y.pRe.ToDouble)
                Next
                chart1.ChartAreas(0).AxisX = AxisX
            Else
                'chart1.Titles.Add(sFn)
                AxisX.Title = "Real"
                chart1.ChartAreas(0).AxisY.Title = "Imaginary"
                Dim maxX, minX, maxY, minY As Double
                maxX = Double.MinValue
                minX = Double.MaxValue
                maxY = Double.MinValue
                minY = Double.MaxValue
                Dim nRows As Int32 = mP.ret.exprMtx.Rows
                Dim vCjo(nRows - 1) As Complex
                ReDim vX(nRows - 1)
                ReDim vY(nRows - 1)
                For i As Int32 = 0 To nRows - 1
                    Dim cjo As Complex = mP.ret.exprMtx.getExpr(i, 0).toComplex
                    Dim x1 As Double = cjo.pRe.ToDouble
                    Dim y1 As Double = cjo.pIm.ToDouble
                    If x1 > maxX Then maxX = x1
                    If x1 < minX Then minX = x1
                    If y1 > maxY Then maxY = y1
                    If y1 < minY Then minY = y1
                    vCjo(i) = cjo
                    If bRnd Then
                        x1 = Math.Round(x1, decimals)
                        y1 = Math.Round(y1, decimals)
                    End If
                    vX(i) = x1
                    vY(i) = y1
                    lst.Add(New KeyValuePair(Of String, String)(i.ToString, cjo.toString(cfg)))
                Next
                If bRnd Then
                    minX = Math.Round(minX, decimals)
                    maxX = Math.Round(maxX, decimals)
                    minY = Math.Round(minY, decimals)
                    maxY = Math.Round(maxY, decimals)
                End If
                If maxX = minX Then maxX += 1
                Dim incrX As Double = (maxX - minX) / nRows
                If bRnd Then
                    incrX = Math.Round(incrX, decimals)
                End If
                AxisX.Interval = incrX
                AxisX.Minimum = minX
                AxisX.Maximum = maxX
                If maxY = minY Then maxY += 1
                Dim incrY As Double = (maxY - minY) / nRows
                If bRnd Then
                    incrY = Math.Round(incrY, decimals)
                End If
                chart1.ChartAreas(0).AxisY.Interval = incrY
                chart1.ChartAreas(0).AxisY.Minimum = minY - Math.Abs(minY / 5)
                chart1.ChartAreas(0).AxisY.Maximum = maxY + Math.Abs(maxY / 5)


                chart1.ChartAreas(0).AxisX = AxisX
                'chart1.Series(sX).IsValueShownAsLabel = True
                'Array.Sort(vX, vCjo)
                For i As Int32 = 0 To nRows - 1
                    Dim cjo As Complex = vCjo(i)
                    Dim x1 As Double = vX(i)
                    Dim y1 As Double = vY(i)
                    lst.Add(New KeyValuePair(Of String, String)(i.ToString, cjo.toString(cfg)))
                    chart1.Series.Add("S" + (i + 1).ToString)
                    chart1.Series(i).Color = Color.Red
                    chart1.Series(i).ChartType = DataVisualization.Charting.SeriesChartType.Point
                    chart1.Series(i).IsValueShownAsLabel = True
                    chart1.Series(i).Points.AddXY(x1, y1)
                Next
            End If


        Catch ex As Exception

        End Try
        Return mP
    End Function
    Public Sub draw()
        'make the three series plot lines 

        chart1.Series.Clear()
        Dim sX As String = p.var(0)
        chart1.Series.Add(sX)
        chart1.Series(sX).Color = Color.Red
        chart1.Series(sX).ChartType = DataVisualization.Charting.SeriesChartType.Line
        Dim root As Double = 0.0
        Try
            If p.roots Is Nothing Then
                Dim r As retOpRoots = Polynomial.opRoots(p)
            End If
            root = p.roots.cjo(0).pRe.ToDouble
        Catch ex As Exception

        End Try


        For x As Double = -14.9 + root To root + 15 Step 0.1
            'calculate the y value for each x value
            'then add that point to the series line
            Dim y As Double = p.evalRe(x)
            chart1.Series(sX).Points.AddXY(x, y)
        Next
    End Sub
    Public Function ToImage() As Bitmap
        Dim bmp As Bitmap = Nothing
        Try
            bmp = New Bitmap(chart1.Height, chart1.Width)
            chart1.DrawToBitmap(bmp, New Rectangle(0, 0, chart1.Height, chart1.Width))
        Catch ex As Exception

        End Try
        Return bmp
    End Function
    Public Function ToBase64() As String
        Dim str As String = ""
        Try
            Dim bmp As Bitmap = Nothing
            bmp = New Bitmap(chart1.Height, chart1.Width)
            chart1.DrawToBitmap(bmp, New Rectangle(0, 0, chart1.Height, chart1.Width))
            Dim ms As New MemoryStream
            bmp.Save(ms, Imaging.ImageFormat.Png)
            Dim byteArr() As Byte = ms.ToArray
            str = Convert.ToBase64String(byteArr)
        Catch ex As Exception

        End Try
        Return str
    End Function
End Class
